    001/*
    002 * Copyright (c) 2007-2017 Xplenty, Inc. All Rights Reserved.
    003 *
    004 * Project and contact information: http://www.cascading.org/
    005 *
    006 * This file is part of the Cascading project.
    007 *
    008 * Licensed under the Apache License, Version 2.0 (the "License");
    009 * you may not use this file except in compliance with the License.
    010 * You may obtain a copy of the License at
    011 *
    012 *     http://www.apache.org/licenses/LICENSE-2.0
    013 *
    014 * Unless required by applicable law or agreed to in writing, software
    015 * distributed under the License is distributed on an "AS IS" BASIS,
    016 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    017 * See the License for the specific language governing permissions and
    018 * limitations under the License.
    019 */
    020
    021package cascading.operation;
    022
    023import cascading.flow.FlowProcess;
    024
    025/**
    026 * Interface Filter marks a given {@link Operation} as a filter, as opposed to being a {@link Function}.
    027 * <p/>
    028 * A Filter is responsible for testing a Tuple to see if it should be removed from the tuple stream.
    029 * <p/>
    030 * To implement a Filter, (optionally) sub-class {@link BaseOperation} and have the new sub-class {@code implement}
    031 * this interface.
    032 */
    033public interface Filter<Context> extends Operation<Context>
    034  {
    035  /**
    036   * Method isRemove returns true if input should be removed from the tuple stream.
    037   *
    038   * @param flowProcess of type FlowProcess
    039   * @param filterCall  of type FilterCall
    040   * @return boolean
    041   */
    042  boolean isRemove( FlowProcess flowProcess, FilterCall<Context> filterCall );
    043  }